// Code generated by go-swagger; DO NOT EDIT.

package builds

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// BuildAbortReader is a Reader for the BuildAbort structure.
type BuildAbortReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *BuildAbortReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewBuildAbortOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewBuildAbortBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewBuildAbortUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewBuildAbortNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 429:
		result := NewBuildAbortTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewBuildAbortInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewBuildAbortOK creates a BuildAbortOK with default headers values
func NewBuildAbortOK() *BuildAbortOK {
	return &BuildAbortOK{}
}

/*BuildAbortOK handles this case with default header values.

OK
*/
type BuildAbortOK struct {
	Payload *models.V0BuildAbortResponseModel
}

func (o *BuildAbortOK) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/builds/{build-slug}/abort][%d] buildAbortOK  %+v", 200, o.Payload)
}

func (o *BuildAbortOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.V0BuildAbortResponseModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBuildAbortBadRequest creates a BuildAbortBadRequest with default headers values
func NewBuildAbortBadRequest() *BuildAbortBadRequest {
	return &BuildAbortBadRequest{}
}

/*BuildAbortBadRequest handles this case with default header values.

Bad Request
*/
type BuildAbortBadRequest struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *BuildAbortBadRequest) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/builds/{build-slug}/abort][%d] buildAbortBadRequest  %+v", 400, o.Payload)
}

func (o *BuildAbortBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBuildAbortUnauthorized creates a BuildAbortUnauthorized with default headers values
func NewBuildAbortUnauthorized() *BuildAbortUnauthorized {
	return &BuildAbortUnauthorized{}
}

/*BuildAbortUnauthorized handles this case with default header values.

Unauthorized
*/
type BuildAbortUnauthorized struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *BuildAbortUnauthorized) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/builds/{build-slug}/abort][%d] buildAbortUnauthorized  %+v", 401, o.Payload)
}

func (o *BuildAbortUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBuildAbortNotFound creates a BuildAbortNotFound with default headers values
func NewBuildAbortNotFound() *BuildAbortNotFound {
	return &BuildAbortNotFound{}
}

/*BuildAbortNotFound handles this case with default header values.

Not Found
*/
type BuildAbortNotFound struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *BuildAbortNotFound) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/builds/{build-slug}/abort][%d] buildAbortNotFound  %+v", 404, o.Payload)
}

func (o *BuildAbortNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBuildAbortTooManyRequests creates a BuildAbortTooManyRequests with default headers values
func NewBuildAbortTooManyRequests() *BuildAbortTooManyRequests {
	return &BuildAbortTooManyRequests{}
}

/*BuildAbortTooManyRequests handles this case with default header values.

Too Many Requests
*/
type BuildAbortTooManyRequests struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *BuildAbortTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/builds/{build-slug}/abort][%d] buildAbortTooManyRequests  %+v", 429, o.Payload)
}

func (o *BuildAbortTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBuildAbortInternalServerError creates a BuildAbortInternalServerError with default headers values
func NewBuildAbortInternalServerError() *BuildAbortInternalServerError {
	return &BuildAbortInternalServerError{}
}

/*BuildAbortInternalServerError handles this case with default header values.

Internal Server Error
*/
type BuildAbortInternalServerError struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *BuildAbortInternalServerError) Error() string {
	return fmt.Sprintf("[POST /apps/{app-slug}/builds/{build-slug}/abort][%d] buildAbortInternalServerError  %+v", 500, o.Payload)
}

func (o *BuildAbortInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
